##################################
### RandRead.tcl               ###
### Version 1.1                ###
### By Wcc                     ###
### wcc@techmonkeys.org        ###
### http://www.dawgtcl.com:81/ ###
### EFnet #|DAWG|Tcl           ###
##################################

############################################################################
### Copyright  2000 - 2002 |DAWG| Scripting Group. All rights reserved. ###
############################################################################

##############################################################################
## This script sends a random line from a file to a channel every x seconds. #
##############################################################################

##############
## COMMANDS ##
######################################################################
## DCC ## .chanset <channel> +/-randread                            ##
######### Enables or disables the sending of random messages to the ##
######### specified channel.                                        ##
######################################################################

##########################################################
## Just load the script, edit the settings, and rehash. ##
##########################################################

##################################################
# Set the time in seconds between messages here. #
##################################################

set randread_setting(timer) "90"

############################################################################
# Set the file to read from here. This file must exist. NOTE: Changing the #
# contents of this file requires a rehash for the changes to take effect.  #
############################################################################

set randread_setting(file) "./README"

####################
# Code begins here #
####################

if {![string match 1.6.* $version]} { putlog "\002RANDREAD:\002 \002WARNING:\002 This script is intended to run on eggdrop 1.6.x or later." }
if {[info tclversion] < 8.2} { putlog "\002RANDREAD:\002 \002WARNING:\002 This script is intended to run on Tcl Version 8.2 or later." }

set ::randread_data [split [read [set fd [open $::randread_setting(file) r]]] "\n"]
setudef flag randread

if {[lsearch -glob [utimers] "* randread_timeread *"] == -1} { utimer $randread_setting(timer) randread_timeread }

proc randread_timeread {} {
	foreach chan [channels] {
		set index [rand [llength $::randread_data]]
		if {[botonchan $chan] && [lsearch -exact [channel info $chan] +randread] != -1} { putserv "PRIVMSG $chan :[join [lrange $::randread_data $index $index]]" }
	}
	if {[lsearch -glob [utimers] "* randread_timeread *"] == -1} { utimer $::randread_setting(timer) randread_timeread }
}

putlog "\002RANDREAD:\002 RandRead.tcl Version 1.1 by Wcc is loaded."
